#! /usr/bin/env dshell

import 'package:dshell/dshell.dart';
import 'package:dshell/src/pubspec/global_dependencies.dart';

/// dshell script generated by:
/// dshell create add_override.dart
///
/// See
/// https://pub.dev/packages/dshell#-installing-tab-
///
/// For details on installing dshell.
///

void main() {
  // activate_local lives in the tool directory
  // so its parent directory should be the dshell package root.
  var dshellPackageRoot = canonicalize(absolute('..'));

  var dependency = join(Settings().dshellPath, GlobalDependencies.filename);

  if (exists(dependency)) {
    delete(dependency);
  }

  // make certain all script see the new settings.
  '${DShellPaths().dshellName} install -nc'.run;

  dependency.append('dependency_overrides:');
  dependency.append('  dshell:');
  dependency.append('    path: $dshellPackageRoot');

  print(GlobalDependencies.filename);
  cat(dependency);
}
